poj 3126 Prime Path (线性素数筛 + bfs)

来源:互联网 发布:java音乐网站 编辑:程序博客网 时间:2024/04/30 19:26

题目链接:poj 3126

Prime Path

Time Limit: 1000MS Memory Limit: 65536K

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

感觉题目略臭长。

给你两个四位数的质数,问你从一个数变成另一个数需要多少步,不可能达到就输出”Impossible”。

根据题目,每一步变化要遵循以下规则:
1.每次变化只能改变当前数中的其中一位数字;
2.每次变化得到的数都必须是质数。

于是又是一道思路十分耿直的bfs,无非是多了个素数筛打表。bfs每一步都查找分别改变四位数字后可以得到的所有质数并入队,每次出队都判断是否和所求数相等即可。

PS:前几天在poj上写这道题结果写完还没交poj就炸了……然后第二天发现国内oj炸了好多,都不知道去哪刷水题了,心塞……

#include <iostream>#include <string>#include <cstdio>#include <algorithm>#include <cstring>#include <ctime>#include <cmath>#include <queue>#include <map>#define M 10005#define INF 0x3f3f3f3fusing namespace std;bool f[M], vis[M];struct node{    int id, step;}st, ed, tmp, t;int g[4][3] = {{1000, 10000, 1000}, {100, 1000, 100}, {10, 100, 10}, {1, 10, 1}};void prime()//素数筛打表{    for(int i = 2; i < M; i++)        if(!f[i])            for(int j = 2; i * j < M; j++)                f[i * j] = true;}int bfs(){    memset(vis, true, sizeof(vis));    queue<node> Q;    Q.push(st);    vis[st.id] = false;    while(!Q.empty())    {        tmp = Q.front();        if(tmp.id == ed.id) return tmp.step;        Q.pop();        t.step = tmp.step + 1;        for(int i = 0; i < 4; i++)        {            for(int j = 0; j <= 9; j++)            {                if(i == 0 && j == 0)    continue;                t.id = j * g[i][2] + tmp.id % g[i][0] + tmp.id / g[i][1] * g[i][1];                if(!f[t.id] && vis[t.id])                {                    Q.push(t);                    vis[t.id] = false;                }            }        }    }    return -1;}int main(){    prime();    int T;    scanf("%d", &T);    while(T--)    {        scanf("%d %d", &st.id, &ed.id);        int ans = bfs();        if(ans != -1)            printf("%d\n", ans);        else            printf("Impossible\n");    }    return 0;}

运行结果:
这里写图片描述

0 0